
/*
**	inv.c 	invertion time seriese in a frame
*/

#include "x.c"
#define W 700	// display window size
#define M 256	// analyze frame size 
#define N 16	// reverse frame size
#define X0 40	// (X0, Y0) 
#define Y0 W-40

#define WIN_INV	// window invert (multiply window and invert)
#define POW2	// display amplitude^2 other than amplitude
#define DIFF

float cost[M];
float sint[M];
float sig1[M];
float sig2[M];
float pwr[M];
#ifdef WIN_INV
float win[2*N];
#endif
float lp,lp1;

void diff(float *p, float *q) {
	int i;
	*q= *p-lp;
	for(i= 1;i<M;i++) q[i]= p[i] - p[i-1];
	lp= p[M-1];
	for(i= 0;i<M;i++) p[i]= q[i];
}

void integ(float *p) {
	int i;
	*p+= lp1;
	for(i= 1;i<M;i++) p[i]+= p[i-1];
	lp1= p[M-1];
}

main() { int x,y,z,i,j,k,l; float s0,s1;

	for(i= 0;i<M;i++){ sint[i]= sin(2*M_PI*i/M); cost[i]= cos(2*M_PI*i/M); } // make sin and cos table
#ifdef WIN_INV
	/*
	for(i= 0;i<N;i++) win[i]= 1;				// rectangle
	for(i= 0;i<N;i++) win[i]= (i<N/2)?2*i/N:2-2*i/N;	// triangle
	for(i= 0;i<N;i++) win[i]= sin(M_PI*i/N);		// half-excurtion sine
	*/
	for(i= 0;i<2*N;i++) win[i]= (1-cos(M_PI*i/(N/2)))/2.;	// cosine
#endif
	iwt("zero",W,W);	// init X-window
	for(i=0;i<W;i++) XDrawLine(dpy,w1,gc,i,W,i,0); // invert whole window from black to white
	XDrawLine(dpy,w1,gc,X0,Y0,X0+M/2,Y0-M/2*4);			// draw j axis
	XDrawLine(dpy,w1,gc,X0,Y0,X0+M/2*4,Y0);				// draw k axis

	for(k=0;k<M/2;k++){
		float s;
		for(i= 0;i<M;i++) sig1[i]= sint[(k*i)%M];		// sin wave
#ifdef DIFF
		lp= lp1= 0;
		diff(sig1,sig2);
#endif
#ifdef WIN_INV	
		for(l= 0;l<M;l+=N) {
		for(i= 0;i<N/2;i++) {
			int j= l + N-1 - i;
			s= sig1[j-N]; sig2[l+i]= win[i]*(sig1[j]-s) + s;
		}
		for(;i<N;i++) {
			int j= l + N-1 - i;
			s= sig1[j+N]; sig2[l+i]= win[i]*(sig1[j]-s) + s;
		}
		}
#else
		for(i= 0;i<M;i++) sig2[i]= sig1[ (i/N)*N+(N-1-i%N) ];	// reverse
		//=for(i= 0;i<M;i++) sig2[i]= sig1[ (i/N)*N*2-i+N-1 ];	// reverse
#endif
#ifdef DIFF
		integ(sig2);
#endif
		/*
		if(k%4==0)
		for(j=0;j<M/2;j++){
			x= X0+j*4+k;
			y= Y0-k*4;
			z= 10*sig2[j];
			if(z) XDrawLine(dpy,w1,gc,x,y,x,y-z);		// draw vertical lines
		}
		*/

		for(j=0;j<M/2;j++){
			x= X0+k*4+j;
			y= Y0-j*4;
			s0= s1= 0;
			for(i=0;i<M;i++){
				s0+= sig2[i]*cost[(i*j)%M];
				s1+= sig2[i]*sint[(i*j)%M];
			}
			pwr[j]= (s0*s0+s1*s1)/M;		// power spectrum
#ifdef POW2
			z= 2*pwr[j];
#else
			z= 10*sqrt(pwr[j]);
#endif
			if(z) XDrawLine(dpy,w1,gc,x,y,x,y-z);		// draw vertical lines
		}
	}
	XFlush(dpy); printf("push return.\n"); getchar();		// wait for return key
}
