/*
**	invert.c 	invert wave file
*/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define N 110		// frame size 22 for vowels exchange, 110 for pitch change
#define WIN_INV		// window inversion
//#define DIFF
typedef double sig;
short signal[N*2];	// input buffer
short signal2[N*2];	// output buffer
sig sig1[N*4];
sig sig2[N*4];
sig win[N];
FILE *fp1,*fp2;
double t0,t1,s0,s1;

void
diff(short *p,sig *f)
{	
	int i;
	f[0]= p[0] - t0;
	f[1]= p[1] - t1;
	for(i= 2;i<2*N;i++) f[i]= p[i]-p[i-2];
	t0= p[2*N-2];
	t1= p[2*N-1];
}
void
integ(sig *p)
{
	int i;
	p[0]+= s0;
	p[1]+= s1;
	for(i= 2;i<2*N;i++) p[i]+= p[i-2];
	s0= p[2*N-2];
	s1= p[2*N-1];
}

void
trans(short *q, sig *p)
{
	int i;
	for(i=0;i<2*N;i++)
		if(p[i]>32767)q[i]= 32767;
		else if(p[i]<-32768)q[i]= -32768;
		else q[i]= p[i];
}

void er(char *c, char *d) { fprintf(stderr,"%s %s\n",c,d); exit(1); }

int
main(int c, char **v)
{
	int i,j,l;
	int sum_l=0;

	for(i= 0;i<N;i++) win[i]= (1-cos(M_PI*i/(N/2)))/2.; // cosine window

	if(c!=3) er(*v,"in.wav out.wav");
	if(!(fp1= fopen(v[1], "rb"))) er("I can't open", v[1]);
	if(!(fp2= fopen(v[2], "wb"))) er("I can't make", v[2]);
	if(fread(signal,1,44,fp1)==44) fwrite(signal2,1,44,fp2);

	while((l= fread(signal,sizeof(short)*2,N,fp1))>0){
		sum_l+= l; if(sum_l>=44100*2*8) exit(0);

		for(i=0;i<2*N;i++) sig1[i]= sig1[i+2*N];
#ifdef DIFF
		diff(signal,sig1+2*N);
#else
		for(i=0;i<2*N;i++) sig1[i+2*N]= signal[i];
#endif
#ifdef WIN_INV	
		for(i= 0;i<N/2;i++) { int j= N-1-i;
			sig s= sig1[j*2-N];	sig2[i*2  ]= s+win[j]*(sig1[j*2+  N]-s);
			s= sig1[j*2+1-N];	sig2[i*2+1]= s+win[j]*(sig1[j*2+1+N]-s);
		}
		for(;i<N;i++) { int j= N-1-i;
			sig s= sig1[j*2+3*N];	sig2[i*2  ]= s+ win[j]*(sig1[j*2+  N]-s);
			s= sig1[j*2+1+3*N];	sig2[i*2+1]= s+ win[j]*(sig1[j*2+1+N]-s);
		}
#else
		for(i= 0;i<N;i++) { //== (i/N)*N*2-i+N-1 // reverse
			sig2[i*2  ]= sig1[2*((i/N)*N+(N-1-i%N))  ];
			sig2[i*2+1]= sig1[2*((i/N)*N+(N-1-i%N))+1];
		}
#endif
#ifdef DIFF
		integ(sig2);
#endif
		trans(signal2, sig2);
		l= fwrite(signal2,sizeof(short)*2,N,fp2);
	}
	fclose(fp1); fclose(fp2);
	return 0;
}
